#################
#Nov 13, 2014
#Phil Boonstra
#Code to generate a list of lists of simulation settings. 
#To be called by the 'MisclassSims_X.R' script. 
################


#Common settings
if(!"niter"%in%ls()){niter=5e3;}
if(!"nsnp"%in%ls()){nsnp=1e5;}
if(!"gw_alpha"%in%ls()){gw_alpha=5e-2;}
if(!"screen_alpha_lax"%in%ls()){screen_alpha_lax=5e-2;}
if(!"screen_alpha_rigid"%in%ls()){screen_alpha_rigid=5e-4;}
if(!"include_constrained"%in%ls()){include_constrained=F;}
#if(!"offset"%in%ls()){offset=0;}

#Settings that vary
if(!"sampsize_list"%in%ls()){sampsize_list=list(list(ncase=1e4,ncontrol=1e4),list(ncase=2e4,ncontrol=2e4));}
if(!"exposure_param_list"%in%ls()){
  exposure_param_list = list(list(marg_OR_E=1.50,prob_E=0.3,sens_E_case=1.00,spec_E_case=1.00,sens_E_control=1.00,spec_E_control=1.00),
                             list(marg_OR_E=1.50,prob_E=0.3,sens_E_case=0.80,spec_E_case=0.80,sens_E_control=0.80,spec_E_control=0.80),
                             list(marg_OR_E=1.50,prob_E=0.3,sens_E_case=1.00,spec_E_case=0.80,sens_E_control=0.80,spec_E_control=0.80),
                             list(marg_OR_E=1.75,prob_E=0.1,sens_E_case=1.00,spec_E_case=1.00,sens_E_control=1.00,spec_E_control=1.00),
                             list(marg_OR_E=1.75,prob_E=0.1,sens_E_case=0.60,spec_E_case=0.60,sens_E_control=0.60,spec_E_control=0.60));
  
}

#Fixed parameter settings
if(!"causal_maf"%in%ls()){causal_maf=0.2;} 
if(!"GxE_assc_sd"%in%ls()){GxE_assc_sd=log(1.5)/2;}
if(!"null_OR_E"%in%ls()){null_OR_E=1.5;}
if(!"prob_GxE_ind_seq"%in%ls()){prob_GxE_ind_seq = c(0.995,0.999,1.0);}
if(!"causal_OR_GxE_assc_seq"%in%ls()){causal_OR_GxE_assc_seq = c(0.8,1.0,1.1);}
if(!"causal_OR_GxE_seq"%in%ls()){causal_OR_GxE_seq = c(seq(1.05,1.33,length=8),seq(1.45,1.94,length=8));}
if(!"causal_OR_G_seq"%in%ls()){causal_OR_G_seq=c(1,1.2);}
if(!"causal_OR_E_seq"%in%ls()){causal_OR_E_seq=NA;}# marg_OR_E is specified
if(!"num_null_with_nonnull_OR_G_seq"%in%ls()){num_null_with_nonnull_OR_G_seq =c(0,500);};

if(!"arglist"%in%ls()){arglist = list();}
sim_number = length(arglist)+1;

for(num_null_with_nonnull_OR_G in num_null_with_nonnull_OR_G_seq) {
  
  for(i in 1:length(exposure_param_list)) {
  
    sens_E_case = exposure_param_list[[i]]$sens_E_case;
    spec_E_case = exposure_param_list[[i]]$spec_E_case;
    sens_E_control = exposure_param_list[[i]]$sens_E_control;
    spec_E_control = exposure_param_list[[i]]$spec_E_control;
    marg_OR_E = exposure_param_list[[i]]$marg_OR_E; 
    prob_E = exposure_param_list[[i]]$prob_E; 
    for(k in 1:length(sampsize_list)) {
      ncase = sampsize_list[[k]]$ncase;
      ncontrol = sampsize_list[[k]]$ncontrol;
    
      for(prob_GxE_ind in prob_GxE_ind_seq) { 
        for(causal_OR_GxE_assc in causal_OR_GxE_assc_seq) { 
          for(causal_OR_GxE in causal_OR_GxE_seq) {
            for(causal_OR_G in causal_OR_G_seq) {
              for(causal_OR_E in causal_OR_E_seq) {
                random_seed = sample(2^30.9,1);
                assign(paste("sim",sim_number,".params",sep=""),list(niter=niter,ncase=ncase,ncontrol=ncontrol,nsnp=nsnp,
                    gw_alpha=gw_alpha,screen_alpha_lax=screen_alpha_lax,screen_alpha_rigid=screen_alpha_rigid,
                    prob_E=prob_E,marg_OR_E=marg_OR_E,sens_E_case=sens_E_case,spec_E_case=spec_E_case,
                    sens_E_control=sens_E_control,spec_E_control=spec_E_control,
                    random_ORs=F,
                    OR_GxE_assc_params = NA,
                    marg_OR_G_params = NA,
                    int_type_dist = NA,                                                 
                    causal_maf=causal_maf,
                    prob_GxE_ind=prob_GxE_ind,GxE_assc_sd=GxE_assc_sd,causal_OR_GxE_assc=causal_OR_GxE_assc,
                    null_OR_E=null_OR_E,causal_OR_E=causal_OR_E,
                    num_null_with_nonnull_OR_G=num_null_with_nonnull_OR_G ,causal_OR_G=causal_OR_G,causal_OR_GxE=causal_OR_GxE,
                    include_constrained=include_constrained,
                    random_seed=random_seed,sim_number=sim_number))
                  arglist = c(arglist,list(get(paste("sim",sim_number,".params",sep=""))))
                  sim_number = sim_number + 1;
              }
            }
          }
        }
      }
    }
  }
}



