#################
#Nov 13, 2014
#Phil Boonstra
#Code to run a single simulation setting or a suite of simulation settings. 
#If my.work.computer = F, then it is assumed that 
#this is called from a Linux cluster running Slurm
################

rm(list=ls(all=TRUE));
require(CGEN);
my.work.computer=F;

if(!my.work.computer) {
  array_id <- as.numeric(Sys.getenv('SLURM_ARRAY_TASK_ID'));
  #Change this as needed to run different subsets of simulations
  offset = 0#Choose from 0 or 990 to run two sets of simulations;
  #niter = 5e3;
} else {
  offset = 0;
	array_id = 1205;
	niter = 25;
}

file.name = "Misclass_AJE";

#arglist is a list of lists, each of which contains
#different simulation settings. The first set of lists
#is for measuring type 1 error rates, the second set
#is for measuring power 

causal_OR_GxE_assc_seq = 1.0;
causal_OR_GxE_seq = 1.0;
causal_OR_G_seq = 1.0;
source("GenParams_AJE.R");

rm(causal_OR_GxE_assc_seq,causal_OR_GxE_seq,causal_OR_G_seq);
prob_GxE_ind_seq = 0.995;
source("GenParams_AJE.R");

rm(list=setdiff(ls(),c("arglist","my.work.computer","file.name","array_id","offset")))
source("FunctionsMisclass.R");

timings = system.time(assign(paste("sim",array_id+offset,sep=""),GwaspowerRand.wrapper(arglist[[array_id+offset]])));
cat(array_id+offset,":",as.numeric(timings[3])/3600,"hours\n",file="results.txt",append=T);

save(list=paste("sim",array_id+offset,sep=""),file=paste(file.name,array_id+offset,".RData",sep=""));
